using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using PCI.D64HU ;
using System.Reflection;

namespace CWave
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

        }
        Int16 wTotalBoards;
        UInt16 wBoardNo;
        Byte bSelCardID;
        uint dwDataNum = 40960;
        short iRtn;
        UInt32[] DoBuf = new UInt32[10240];
        UInt32[] DiBuf = new UInt32[40960];
        const double pi = 3.1215926535879;
        const double degree = pi/180.0;
        const uint maximum_fifo_loop_count = 2048;


        private void Form1_Load(object sender, EventArgs e)
        {
            UInt16 index = 0;
            Byte bCardID = 0;
            
            Int16 iRtn;
            short wBoardIndex;
            Byte[] bIndex = new Byte[15];


            wTotalBoards = 0;         

            iRtn = (short)PCI.D64HU.Functions.d64h_scan(ref wTotalBoards, ref bIndex[0]);
            if (iRtn != (Int16)PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
            {
                MessageBox.Show("Driver Inital Error!!Error Code:" + iRtn.ToString());
                Close();
                return;
            }
            //tbxInput.Text  = "0x0";
            //tbxOutput.Text  = "0x0";

            cbxSelBoard.Items.Clear();
            for (wBoardIndex = 0; wBoardIndex < wTotalBoards; wBoardIndex++)
            {
                //Get Card Info
                iRtn = PCI.D64HU.Functions.d64h_cardinfo_get((ushort)wBoardIndex, ref bCardID);
                if (iRtn != (Int16)PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("Get Card Info error!!Error Code:" + iRtn.ToString());
                    Close();
                    return;
                }
                cbxSelBoard.Items.Add(wBoardIndex.ToString() + ":0x" + Convert.ToString(bCardID, 16));
                //this.cbxSelBoard.Items.Add("0x");
            }        
            
            tbxYup.Text = "0xFFFFFFFF";
            
            tbxYdown.Text = "0x0";
            
            for (index = 0; index <= 10240 - 1; index++) {
                //DoBuf(index) = CLng(327679.5 * Math.Sin((index Mod 1024) * 360 / 1024 * degree) + 327679.5)
                
                    
                DoBuf[index] = (UInt32)(2147483647.5 * Math.Sin((index % 1024) * 360 / 1024 * degree) + 2147483647.5);
            }


            //MessageBox.Show((Convert.(tbxYup.Text)).ToString());
        } 
           

        private void cbxSelBoard_SelectedIndexChanged(object sender, EventArgs e)
        {

            Int16 iRtn;

            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            //Get Card Info
            iRtn = PCI.D64HU.Functions.d64h_cardinfo_get(wBoardNo, ref bSelCardID);

            if (iRtn != PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
            {
                MessageBox.Show("Get Card Information Err:" + iRtn.ToString());
            }


            this.Text = this.cbxSelBoard.Text + " CWave Demo";
        }

        private void btnExit_Click(object sender, EventArgs e)
        {       
            //Release the UniDAQ Driver resource
          
            Application.Exit();
            this.Close();
        }    

        private void btnActive_Click(object sender, EventArgs e)
        {
            UInt32 dwBufLen=0;
            uint count;
 
            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            dwDataNum = Convert.ToUInt32(tbxDataNum.Text);
            if (btnActive.Text == "&ACTIVE")
            {
                btnActive.Text = "&STOP";
                timer1.Enabled = true;
                btnExit.Enabled = false;
                //bDisplay = true;
                iRtn = PCI.D64HU.Functions.d64h_open(bSelCardID);
                if (iRtn != (Int16)PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("Close Error" + iRtn.ToString());                  
                    return;
                }


                iRtn = PCI.D64HU.Functions.d64h_di_available_memory(bSelCardID, ref dwBufLen);
                if (iRtn != (Int16)PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("Available memory Error" + iRtn.ToString());                  
                    return;
                }

                if (dwDataNum * 4 > dwBufLen * 1024)
                {
                    MessageBox.Show("Memory Error" );                  
                    return;
                }

                //Config DO
                iRtn = PCI.D64HU.Functions.d64h_do_config(bSelCardID, PCI.D64HU.Param.TRIG_SOURCE_INT_PACER, PCI.D64HU.Param.OREQ_DISABLE, PCI.D64HU.Param.OTRIG_HIGH);
                if (iRtn != (Int16)PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("DO Config Error.Error Code =" + iRtn.ToString());                  
                    return;
                }
               
                //Config DI
                iRtn = PCI.D64HU.Functions.d64h_di_config(bSelCardID, PCI.D64HU.Param.TRIG_SOURCE_INT_PACER, PCI.D64HU.Param.DI_NOWAITING, PCI.D64HU.Param.DI_TRIG_RISING, PCI.D64HU.Param.IREQ_FALLING);
                if (iRtn != (Int16)PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("Close Error" + iRtn.ToString());                  
                    return;
                }

                // Enable DI double-buffer mode
                iRtn = PCI.D64HU.Functions.d64h_di_async_dblbuf_mode(bSelCardID, PCI.D64HU.Param.DOUBLE_BUFFER_MODE_ENABLE);
                if (iRtn != (Int16)PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("Close Error" + iRtn.ToString());                  
                    return;
                }

                // Disable DO double-buffer mode
                iRtn = PCI.D64HU.Functions.d64h_do_async_dblbuf_mode(bSelCardID, PCI.D64HU.Param.DOUBLE_BUFFER_MODE_DISABLE);
                 if (iRtn != (Int16)PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("Disable DO double-buffer mode Error.Error Code =" + iRtn.ToString());                  
                    return;
                }
          
                 // Disable DO double-buffer mode
                iRtn = PCI.D64HU.Functions.d64h_conti_pattern_write(bSelCardID, ref DoBuf[0], maximum_fifo_loop_count, 100000.0);
                if (iRtn != (Int16)PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("d64h_conti_pattern_write Error.Error Code =" + iRtn.ToString());                  
                    return;
                }

                //Read Port
                iRtn = PCI.D64HU.Functions.d64h_conti_readport(bSelCardID, ref DiBuf[0], dwDataNum, Convert.ToSingle(tbxSRate.Text) * 1000, PCI.D64HU.Param.ASYNCH_OP);
                if (iRtn != PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("Conti Read Port Error.Error Code =" + iRtn.ToString());
                    return;
                }             

            }
            else
            {
                btnActive.Text = "&ACTIVE";
                timer1.Enabled = false;
                btnExit.Enabled = true;
                count = 0;
                iRtn = PCI.D64HU.Functions.d64h_di_async_clear(bSelCardID, ref count);
                if (iRtn != PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("Count Read Port Error.Error Code =" + iRtn.ToString());
                    return;
                }             

                iRtn = PCI.D64HU.Functions.d64h_do_async_clear(bSelCardID, ref count);
                if (iRtn != PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("Count Write Port Error.Error Code =" + iRtn.ToString());
                    return;
                }             
             
                //Close Card
                iRtn = PCI.D64HU.Functions.d64h_close(bSelCardID);
                if (iRtn != PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("Close Card Error.Error Code=" + iRtn.ToString());
                    return;
                }          
               
            }           
           
        }      
      

        /*
        private void pbxDisplay_Paint(object sender, PaintEventArgs e)
        {             
             if (bDisplay == true)
             {   
                 Graphics g =e.Graphics;
                 PlotData(g);
             }
        }*/

        //Draw the Graphics for Analog Input Data
        private void PlotData(Graphics g)
        {
            //float Yup = 20.0F, Ydown = -20.0F;
            float fScaleX, fScaleY;
            Pen RedPen = new Pen(Color.Red);
            Pen BlackPen = new Pen(Color.Black);
            PointF[] PointArray = new PointF[dwDataNum];
            PointF[] LPointArray = new PointF[dwDataNum];
            PointF[] LBaseArray = new PointF[1];


            for (int i = PointArray.GetLowerBound(0); i <= PointArray.GetUpperBound(0); i++)
            {
                PointArray[i].X = i;
                PointArray[i].Y =DiBuf[i];
            }

            fScaleX = (float)pbxDisplay.Width / PointArray.Length;
            fScaleY = (float)(pbxDisplay.Height * 0.97) / (float)(4294967295.0);

            for (int i = PointArray.GetLowerBound(0); i <= PointArray.GetUpperBound(0); i++)
            {
                LPointArray[i].X = (float)(PointArray[i].X * fScaleX);
                LPointArray[i].Y = (float)((4294967295.0 - PointArray[i].Y) * fScaleY);

            }
            pbxDisplay.Refresh();
            g.DrawLines(RedPen, LPointArray);
            //pbxDisplay.Refresh();

            RedPen.Dispose();
            //g.Dispose();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            Byte bHalfReady = 0;
            short bufferIndex = 0;
            Graphics gr = pbxDisplay.CreateGraphics();

            dwDataNum = (UInt32)(Convert.ToUInt16(tbxDataNum.Text) / 2.0);

             //Check DI FIFO-half
            iRtn = PCI.D64HU.Functions.d64h_di_async_dblbuf_halfready(bSelCardID , ref bHalfReady, ref bufferIndex );
            if(iRtn!= PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
            {
                MessageBox.Show("async_dblbuf_halfready Error|!Error Code:" + iRtn.ToString());
                return;
            }
            //Ready
            if(bHalfReady>0)
            {
                iRtn = PCI.D64HU.Functions.d64h_di_async_dblbuf_transfer(bSelCardID, ref DiBuf[0]);
                if(iRtn!= PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("async_dblbuf_transfer|!Error Code:" + iRtn.ToString());
                    return;
                }
                PlotData(gr);
                Application.DoEvents();
            }
            
            //Application.DoEvents();
            //this.pbxDisplay_Paint(pbxDisplay, new PaintEventArgs(pbxDisplay.CreateGraphics(), Rectangle.Empty));               
           
          
            gr.Dispose();
        }
        
        
       

    }
}