using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using PCI.D64HU;
using System.Reflection;    //namespace P100X_Ns 

namespace DIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();


        }
        ArrayList mpbOutputs = new ArrayList();
        ArrayList mpbInputs = new ArrayList();
               
        UInt16 wBoardNo;       
        Byte bSelCardID;       
        
        private void Form1_Load(object sender, EventArgs e)
        {

            Byte bCardID=0;
            Byte[] bIndex=new Byte[15];
            Int16 iRtn;
            short wTotalBoards, wBoardIndex ;

        
            //bIndex[0] = 0;
            wTotalBoards = 0;
            //StringBuilder sCardName = new StringBuilder();
            
            mpbOutputs = ControlArrayUtils.getControlArray(this.gbxOutput , "pbout", ""); //CreatControlArray
            mpbInputs = ControlArrayUtils.getControlArray(this.gbxInput , "pbin", "");  //CreatControlArray

            for (int i = 1; i <= 32; i++)
            {
                ((PictureBox)mpbOutputs[i]).BackColor = Color.Gray;
                ((PictureBox)mpbOutputs[i]).Enabled = false;
                ((PictureBox)mpbInputs[i]).BackColor = Color.Gray;                                
                ((PictureBox)mpbOutputs[i]).Click += new EventHandler(mpbOutputs_Click); //mpbOutputs Click event
            }
       
            iRtn = (short)PCI.D64HU.Functions.d64h_scan(ref wTotalBoards, ref bIndex[0]);
            if (iRtn != (Int16)PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
            {
                MessageBox.Show("Driver Inital Error!!Error Code:" + iRtn.ToString());
                Close();
                return;
            }
            //tbxInput.Text  = "0x0";
            //tbxOutput.Text  = "0x0";

            cbxSelBoard.Items.Clear();
            for (wBoardIndex = 0; wBoardIndex < wTotalBoards; wBoardIndex++)
            { 
                //Get Card Info
                iRtn = PCI.D64HU.Functions.d64h_cardinfo_get((ushort)wBoardIndex, ref bCardID);
                if (iRtn != (Int16)PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("Get Card Info error!!Error Code:" + iRtn.ToString());
                    Close();
                    return;
                }
                cbxSelBoard.Items.Add(wBoardIndex.ToString()+":0x"+Convert.ToString(bCardID,16));                
                    //this.cbxSelBoard.Items.Add("0x");
            }        

        }

        private void btnActive_Click(object sender, EventArgs e)
        {
            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            Int16 iRtn;

            if (btnActive.Text == "&ACTIVE")
            {
                btnActive.Text = "&STOP";
                Timer1.Enabled = true;
                btnExit.Enabled = false;


                for (int i = 1; i <= 32; i++)
                {
                    ((PictureBox)mpbOutputs[i]).Enabled = true;
                }
                //Open Card
                iRtn = PCI.D64HU.Functions.d64h_open(bSelCardID);
            }else {

                btnActive.Text = "&ACTIVE";
                Timer1.Enabled = false;
                btnExit.Enabled = true;
                for (int i = 1; i <= 32; i++)
                {
                    ((PictureBox)mpbOutputs[i]).Enabled = false;
                }
                //Close Card
                iRtn = PCI.D64HU.Functions.d64h_close(bSelCardID);
                if (iRtn != (Int16)PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
                {
                    MessageBox.Show("Close Error" + iRtn.ToString());
                  
                    return;
                }
            }            
        }

        private void mpbOutputs_Click(object sender, EventArgs e) //mpbOutputs Click event
        {
            Int16 iRtn;
            UInt32 DoVal;
            int index;

            PictureBox pb = (PictureBox)sender;
            int i = Convert.ToUInt16((Convert.ToString(pb.Name)).Remove(0, 5));

            if (((PictureBox)mpbOutputs[i]).BackColor == Color.Gray)
            {
                ((PictureBox)mpbOutputs[i]).BackColor = Color.Red;
            }
            else
            {
                ((PictureBox)mpbOutputs[i]).BackColor = Color.Gray;
            }

        
            DoVal = 0;
            for (index = 1; index <= 32; index++)
            {
                if (((PictureBox)mpbOutputs[index]).BackColor == Color.Red)
                {
                    uint shiftDO = 1;
                    DoVal = (DoVal | (shiftDO << (index-1))); 
                }
            }

            tbxOutput.Text = Convert.ToString(DoVal,16);
            //Write DO Port
            iRtn = PCI.D64HU.Functions.d64h_do_writeport(bSelCardID, DoVal);
            //P100x.DigitOut((uint)DoVal);
            
        }

        private void Timer1_Tick(object sender, EventArgs e)
        {
            UInt32 DIVal;
            int index;
            Int16 iRtn;

            DIVal = 0x0;
            //Write DI Port
            iRtn = PCI.D64HU.Functions.d64h_di_readport(bSelCardID, ref DIVal);

            tbxInput.Text = Convert.ToString(DIVal, 16);
            //P100x.DigitIn(out DIVal);  
            //DIVal = 0;

            for (index = 1;index<= 32;index++)
            {                
                if ((DIVal & (1 << (index-1))) == 0)
                {
                    ((PictureBox)mpbInputs[index]).BackColor = Color.Gray ;
                }else{
                    ((PictureBox)mpbInputs[index]).BackColor = Color.Red;
                }
            }
        }


        private void btnExit_Click(object sender, EventArgs e)
        {
            
            Close();
        }

        private void cbxSelBoard_SelectedIndexChanged(object sender, EventArgs e)
        {
            Int16 iRtn;

            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            //Get Card Info
            iRtn = PCI.D64HU.Functions.d64h_cardinfo_get(wBoardNo, ref bSelCardID);

            if (iRtn != PCI.D64HU.ErrCode.SUCCESS_NO_ERROR)
            {
                MessageBox.Show("Get Card Information Err:" + iRtn.ToString());
            }


            this.Text = this.cbxSelBoard.Text + " Digital I/O LED Demo";
        }

       



    } 
}