using System.Runtime.InteropServices; 
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;

using HANDLE = System.IntPtr; 

namespace PCI.D64HU
{
	public class Param
	{

		public const Int16 D64H_MaxCards = 16; 
		public const Byte INVALID_CARD_ID	= 0xFF;

		public const UInt16 DOUBLE_BUFFER_MODE_ENABLE = 0x01;
		public const UInt16 DOUBLE_BUFFER_MODE_DISABLE = 0x00;
				
		public const UInt16 PARAMETER_IGNORED	= 0xFFFF;
		
		//Clock Mode
		public const UInt16 TRIG_SOURCE_INT_PACER  = 1;
		public const UInt16 TRIG_SOURCE_EXT_STROBE = 2;
		public const UInt16 TRIG_SOURCE_HANDSHAKE = 3;

		// Event type for the event message
		public const UInt16 DIEnd = 0;
		public const UInt16 DOEnd = 0;
		public const UInt16 DBEvent = 1;
		public const UInt16 TrigEvent = 2;

		// Operation for Event
		public const UInt16 ADD_NOTIFICATION = 0x01;
		public const UInt16 REMOVE_NOTIFICATION = 0x00;

		//InputMode
		public const UInt16 DI_WAITING = 0x02;
		public const UInt16 DI_NOWAITING = 0x00;

		public const UInt16 DI_TRIG_RISING = 0x04;
		public const UInt16 DI_TRIG_FALLING = 0x00;

		public const UInt16 IREQ_RISING = 0x08;
		public const UInt16 IREQ_FALLING = 0x00;

		//Output Mode
		public const UInt16 OREQ_ENABLE = 0x10;
		public const UInt16 OREQ_DISABLE = 0x00;

		public const UInt16 OTRIG_HIGH = 0x20;
		public const UInt16 OTRIG_LOW = 0x00;

		//Synchronous Mode
		public const UInt16 SYNCH_OP = 0x01;
		public const UInt16 ASYNCH_OP = 0x02;
		
		//DI DO Status
		public const UInt16 DI_OVERRUN_STATUS = 0x01;
		public const UInt16 DO_UNDERRUN_STATUS = 0x02;
        
	}
	
	public class ErrCode
	{
		//****************
		//Error Code
		//****************
		public const Int16 SUCCESS_NO_ERROR = 0;
		
		public const Int16 ERROR_ROUTINE_FAIL_BASE = -100;
		

		public const Int16 ERROR_DEVICE_OPEN = -102;
		public const Int16 ERROR_DEVICE_CLOSE = -103;
		public const Int16 ERROR_DOUBLE_BUFFER_MODE = -104;
		public const Int16 ERROR_DI_CONFIG = -105;
		public const Int16 ERROR_DI_ASYNC_CLEAR = -106;
		public const Int16 ERROR_DI_ASYNC_CHECK = -107;
 		public const Int16 ERROR_DI_ASYNC_HALF_READY = -108;
		public const Int16 ERROR_DI_PIO_READ = -109;
		public const Int16 ERROR_DO_CONFIG = -110;
		public const Int16 ERROR_DO_ASYNC_CLEAR = -111;
		public const Int16 ERROR_DO_ASYNC_CHECK = -112;
		public const Int16 ERROR_DO_PIO_READ = -113;
		public const Int16 ERROR_DO_PIO_WRITE = -114;
		public const Int16 ERROR_DO_PIO_LINE_WRITE = -115;
		public const Int16 ERROR_CONTINUE_DI_START = -116;
		public const Int16 ERROR_CONTINUE_DO_START = -117;
		public const Int16 ERROR_FIFO_STATUS_GET = -118;
		public const Int16 ERROR_DO_EXT_TRIGLINE_WRITE = -119;
		public const Int16 ERROR_DO_ASYNC_HALF_READY = -120;
		public const Int16 ERROR_DIGITAL_FILTER_SET = -121;
		public const Int16 ERROR_OREQ_WIDTH_SET = -122;
	  
		// Parameters Error
	  public const Int16 ERROR_INVALID_PARAMETER_BASE = -200;		
	  public const Int16 ERROR_INVALID_CARD_ID = -201;
	  public const Int16 ERROR_INVALID_SCANNED_INDEX = -202;
	  public const Int16 ERROR_CARD_ID_DUPLICATED = -203;
	  public const Int16 ERROR_INVILID_DOUBLE_BUFFER_MODE = -204;
	  public const Int16 ERROR_INVALID_PORT_LINE = -205;
	  public const Int16 ERROR_INVALID_TRIGGER_SOURCE = -206;
	  public const Int16 ERROR_INVALID_TRIGGER_ENABLE = -207;
	  public const Int16 ERROR_INVALID_TRIGGER_POLARITY = -208;
	  public const Int16 ERROR_INVALID_IREQ_POLARITY = -209;
	  public const Int16 ERROR_INVALID_OTRIG_LEVEL = -210;
	  public const Int16 ERROR_INVALID_OREG_ENABLE = -211;
	  public const Int16 ERROR_INVALID_DOUBLE_BUFFER_MODE = -212;
	  public const Int16 ERROR_INVALID_SYNCH_OP_MODE = -213;
	  public const Int16 ERROR_SAMPLE_COUNT_IS_ODD = -214;
	  public const Int16 ERROR_INVALID_DO_ITERATIONS = -215;
	  public const Int16 ERROR_INVALID_EVENT_ACTION = -216;
	  public const Int16 ERROR_INVALID_CALLBACK_ADDRESS = -217;
	  public const Int16 ERROR_INVALID_BUFFER_ADDRESS = -218;
	  public const Int16 ERROR_INVALID_PATTERN_SIZE = -219;
	  public const Int16 ERROR_INVALID_FILTER_SETTING = -220;
	  public const Int16 ERROR_INVALID_OREG_WIDTH = -221;  
	  	  
		// RunTime Error
	  public const Int16 ERROR_RUNTIME_BASE = -300;
	  
	  public const Int16 ERROR_NO_CARD_FOUND = -316;
	  public const Int16 ERROR_MEMORY_MAP = -317;
	  public const Int16 ERROR_MEMORY_UNMAP = -318;
	  public const Int16 ERROR_ACCESS_VIOLATION_DATA_COPY = -319;
	  public const Int16 ERROR_VARIABLE_PITCH_SET = -320;
	  public const Int16 ERROR_DI_EVENT_ATTACH = -321;
	  public const Int16 ERROR_DI_EVENT_DETACH = -322;
	  public const Int16 ERROR_DO_EVENT_ATTACH = -323;
	  public const Int16 ERROR_DO_EVENT_DETACH = -324;
	  public const Int16 ERROR_EVENT_CREATE_FAILED = -325;
	  public const Int16 ERROR_OVERLAP_EVENT_CREATE = -326;

	  public const Int16 ERROR_IOCTL_FAILED = -361;
	  public const Int16 ERROR_UNDEFINED_EXCEPTION = -362;

// DIO RunTime Error
	  public const Int16 ERROR_DIO_RUNTIME_BASE = -500;
	  public const Int16 ERROR_DEVICE_POWER_DOWN = -501;
	  public const Int16 ERROR_INVALID_MAPPED_ADDRESS =  -502;
	  public const Int16 ERROR_BUFFER_NOT_ENOUGH = -503;
	  public const Int16 ERROR_DMA_NOT_AVAILABLE = -504;
	  public const Int16 ERROR_DMA_NOT_COMPLETE = -505;
	  public const Int16 ERROR_DMA_NOT_STARTED = -506;
	  public const Int16 ERROR_DMA_NOT_PAUSED = -507;
	  public const Int16 ERROR_DMA_IS_PAUSED = -508;
	  public const Int16 ERROR_DMA_IN_PROGRESS = -509;
	  public const Int16 ERROR_INVALID_SAMPLE_RATE = -510;
	  public const Int16 ERROR_SAMPLE_COUNT_TOO_LARGE = -511;
	  public const Int16 ERROR_SYNCH_OP_WITH_DOUBLE_BUFFER_MODE = -512;
	  public const Int16 ERROR_SYNCH_OP_WITH_ASYNC_CHECK = -513;
	  public const Int16 ERROR_UNSUPPORTED_SETTING = -514;
	  public const Int16 ERROR_PATTERN_OUT_WITH_DOUBLE_BUFFER_MODE = -515;
	  public const Int16 ERROR_PATTERN_OUT_IN_PROGRESS = -516;
        
	}
		
	public class Functions
	{
		//_AXIS_RANGE_SETTINGS_ AXIS_RANGE_SETTINGS  =  new _AXIS_RANGE_SETTINGS_();

        [DllImport("D64HDLL.dll", EntryPoint = "d64h_scan")]
		public static extern Int16 d64h_scan(
											ref Int16 pCardNum, 
											ref Byte pAvailCards
											);

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_cardinfo_get")]
		public static extern Int16 d64h_cardinfo_get(
											UInt16 ScannedIndex,
											ref Byte pCardID
											);
	
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_open")]
		public static extern Int16 d64h_open( Byte bCardID );
		
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_close")]
		public static extern Int16 d64h_close( Byte bCardID );
		
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_di_event_callback")]
		public static extern Int16 d64h_di_event_callback(
											Byte bCardID,  
											UInt16 wEventEnable, 
											UInt16 wEventType, 
											MulticastDelegate callbackAddr
											);

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_event_callback")]
		public static extern Int16 d64h_do_event_callback(
											Byte bCardID,  
											UInt16 wEventEnable, 
											UInt16 wEventType, 
											MulticastDelegate callbackAddr
											);
											
													
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_di_config")]
		public static extern Int16 d64h_di_config(
											Byte bCardID, 
											UInt16 wTrigSource, 
											UInt16 wExtTrigEnable, 											
											UInt16 wTrigPolarity, 
											UInt16 wI_REQ_Polarity
											);

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_di_buffer_get")]
		public static extern Int16 d64h_di_buffer_get(
											Byte bCardID, 
											ref UInt32 pMemSize, 
											ref UInt32 pLowBufAddr, 
											ref UInt32 pHighBufAddr
											);

		// Hardware Configuration Routines (Optional)
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_di_available_memory")]
		public static extern Int16 d64h_di_available_memory(
											Byte bCardID, 
											ref UInt32 pMemSize
											);

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_di_async_clear")]
		public static extern Int16 d64h_di_async_clear(
											Byte bCardID, 
											ref UInt32 pAccessCount
											);
		
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_di_async_check")]
		public static extern Int16 d64h_di_async_check(
											Byte bCardID, 
											ref Byte pStopped, 
											ref UInt32 pAccessCount
											);
		
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_di_async_dblbuf_mode")]
		public static extern Int16 d64h_di_async_dblbuf_mode( 
											Byte bCardID,  
											UInt16 wDblBufEnable 
											);
		
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_di_async_dblbuf_halfready")]
		public static extern Int16 d64h_di_async_dblbuf_halfready(
											Byte bCardID, 
											ref Byte pHalfReady,
											ref Int16 pBufIndex 
											);
        //[DllImport("D64HDLL.dll", EntryPoint = "d64h_di_async_dblbuf_halfready")]
        //public static extern Int16 d64h_di_async_dblbuf_halfready(
        //                                    Byte bCardID,
        //                                    ref Byte pHalfReady                                            
        //                                    );
		// Home Operation
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_di_async_dblbuf_transfer")]
		public static extern Int16 d64h_di_async_dblbuf_transfer(
											Byte bCardID, 
											ref UInt32 pBuffer
											);
		
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_di_readport")]
		public static extern Int16 d64h_di_readport(
											Byte bCardID,				
											ref UInt32 pValue
											);
		
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_di_readline")]
		public static extern Int16 d64h_di_readline(
											Byte bCardID,
											UInt16 wLine,
											ref UInt16 pValue
											);

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_conti_readport")]
		public static extern Int16 d64h_conti_readport(
											Byte bCardID,
											ref UInt32 pBuffer,
											UInt32 dwSampleCount,
											Double fSampleRate,
											UInt16 wSyncMode
											);
    		
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_conti_di_status")]
		public static extern Int16 d64h_conti_di_status(
											Byte bCardID,			
											ref UInt16 pStatus
											);
		
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_config")]
		public static extern Int16 d64h_do_config( 
											Byte bCardID, 
											UInt16 wTrigSource, 
											UInt16 wO_REQ_Enable, 
											UInt16  wOutTrigHigh
											);
											
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_buffer_get")]
		public static extern Int16 d64h_do_buffer_get( 
											ref UInt32 pMemSize, 
											ref UInt32 pLowBufAddr, 
											ref UInt32 pHighBufAddr
											);
		
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_available_memory")]
		public static extern Int16 d64h_do_available_memory( 
											Byte bCardID, 
											ref UInt32 pMemSize
											);
		
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_async_clear")]
		public static extern Int16 d64h_do_async_clear( 
											Byte bCardID, 
											ref UInt32 pAccessCount
											);
		
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_async_check")]
		public static extern Int16 d64h_do_async_check(
											Byte bCardID, 
											ref Byte pStopped, 
											ref UInt32 pAccessCount
											);


		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_async_dblbuf_mode")]
		public static extern Int16 d64h_do_async_dblbuf_mode(
											Byte bCardID,  
											UInt16 wDblBufEnable  
										  );

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_async_dblbuf_halfready")]
		public static extern Int16 d64h_do_async_dblbuf_halfready(
											Byte bCardID, 
											ref Byte pHalfReady,
											ref Int16 pBufIndex 
											);

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_async_dblbuf_transfer")]
		public static extern Int16 d64h_do_async_dblbuf_transfer(
											Byte bCardID, 
											ref UInt32 pBuffer
										  );

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_conti_do_status")]
		public static extern Int16 d64h_conti_do_status(
											Byte bCardID,			
											ref UInt16 pStatus
											);
											
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_readport")]
		public static extern Int16 d64h_do_readport(
											Byte bCardID,				
											ref UInt32 pValue
											);
											
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_readline")]
		public static extern Int16 d64h_do_readline(
											Byte bCardID,
											UInt16 wLine,
											ref UInt16 pValue
											);

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_writeport")]
		public static extern Int16 d64h_do_writeport(
											Byte bCardID,				
											UInt32 dwValue		
											);

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_writeline")]
		public static extern Int16 d64h_do_writeline(
											Byte bCardID,
											UInt16 wLine,
											UInt16 wValue			
											);


		[DllImport("D64HDLL.dll", EntryPoint = "d64h_conti_writeport")]
		public static extern Int16 d64h_conti_writeport(
											Byte bCardID,
											ref UInt32 pBuffer,
											UInt32 dwSampleCount,
											UInt16 wIterations,
											Double fSampleRate,
											UInt16 wSyncMode
										  );
										  
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_conti_pattern_write")]
		public static extern Int16 d64h_conti_pattern_write(
											Byte bCardID,
											ref UInt32 pBuffer,
											UInt32 dwSampleCount,
											Double fSampleRate
										  );

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_do_ext_trigline_write")]
		public static extern Int16 d64h_do_ext_trigline_write(
											Byte bCardID,
											UInt16 wValue
											); 

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_DI_filter_set")]
		public static extern Int16 d64h_DI_filter_set(
											Byte bCardID,
											UInt16 wDIFilter		  
										  );

		[DllImport("D64HDLL.dll", EntryPoint = "d64h_IREQ_filter_set")]
		public static extern Int16 d64h_IREQ_filter_set(
											Byte bCardID,
											UInt16 wIREQFilter		  
										  );
										  
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_OACK_filter_set")]
		public static extern Int16 d64h_OACK_filter_set(
											Byte bCardID,
											UInt16 wOACKFilter		  
										  );
										  
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_ITRG_filter_set")]
		public static extern Int16 d64h_ITRG_filter_set(
											Byte bCardID,
											UInt16 wITRGFilter		  
										  );
										  
		[DllImport("D64HDLL.dll", EntryPoint = "d64h_OREQ_width_set")]
		public static extern Int16 d64h_OREQ_width_set(
											Byte bCardID,
											UInt16 wOREQWidth		  
										  );										  										  										  


	}
}